import { jsx as o } from "react/jsx-runtime";
import { a as r } from "../../../react.esm-GKFzux-6.js";
import "../../../index-7ofMxoL9.js";
import n, { overlayClassName as c } from "../Overlay.js";
import t from "../../enum/PredefinedPosition.js";
import { useOverlayManagerContext as f } from "../../context/OverlayManagerContext.js";
import d from "../../hooks/useForwardOverlayEvents.js";
const T = [
  {
    positionProps: {
      position: t.TOP_LEFT
    },
    expectedStyle: {
      top: 0,
      left: 0
    }
  },
  {
    positionProps: {
      position: t.TOP_LEFT,
      offset: { top: "10%", left: "10%" }
    },
    expectedStyle: {
      top: "10%",
      left: "10%"
    }
  },
  {
    positionProps: {
      position: t.BOTTOM_CENTER
    },
    expectedStyle: {
      bottom: 0,
      left: "50%",
      transform: "translateX(-50%)"
    }
  },
  {
    positionProps: {
      position: t.TOP_RIGHT
    },
    expectedStyle: {
      top: 0,
      right: 0
    }
  },
  {
    positionProps: {
      position: t.TOP_RIGHT,
      offset: { top: "10%", right: "10%" }
    },
    expectedStyle: {
      top: "10%",
      right: "10%"
    }
  },
  {
    positionProps: {
      position: t.BOTTOM_LEFT
    },
    expectedStyle: {
      bottom: 0,
      left: 0
    }
  },
  {
    positionProps: {
      position: t.BOTTOM_LEFT,
      offset: { bottom: "10%", left: "10%" }
    },
    expectedStyle: {
      bottom: "10%",
      left: "10%"
    }
  },
  {
    positionProps: {
      position: t.BOTTOM_RIGHT
    },
    expectedStyle: {
      bottom: 0,
      right: 0
    }
  },
  {
    positionProps: {
      position: t.BOTTOM_RIGHT,
      offset: { bottom: "10%", right: "10%" }
    },
    expectedStyle: {
      bottom: "10%",
      right: "10%"
    }
  },
  {
    positionProps: {
      position: t.TOP_CENTER
    },
    expectedStyle: {
      top: 0,
      left: "50%",
      transform: "translateX(-50%)"
    }
  },
  {
    positionProps: {
      position: t.TOP_CENTER,
      offset: { leftInPercent: 10 }
    },
    expectedStyle: {
      top: 0,
      left: "60%",
      transform: "translateX(-50%)"
    }
  },
  {
    positionProps: {
      position: t.BOTTOM_CENTER,
      offset: { leftInPercent: 10 }
    },
    expectedStyle: {
      bottom: 0,
      left: "60%",
      transform: "translateX(-50%)"
    }
  },
  {
    positionProps: {
      position: t.CENTER
    },
    expectedStyle: {
      top: "50%",
      left: "50%",
      transform: "translate(-50%, -50%)"
    }
  },
  {
    positionProps: {
      position: t.CENTER,
      offset: { topInPercent: 10, leftInPercent: 10 }
    },
    expectedStyle: {
      top: "60%",
      left: "60%",
      transform: "translate(-50%, -50%)"
    }
  },
  {
    positionProps: {
      position: t.MID_LEFT
    },
    expectedStyle: {
      top: "50%",
      left: 0,
      transform: "translateY(-50%)"
    }
  },
  {
    positionProps: {
      position: t.MID_LEFT,
      offset: { topInPercent: 10, left: "10%" }
    },
    expectedStyle: {
      top: "60%",
      left: "10%",
      transform: "translateY(-50%)"
    }
  },
  {
    positionProps: {
      position: t.MID_RIGHT
    },
    expectedStyle: {
      top: "50%",
      right: 0,
      transform: "translateY(-50%)"
    }
  },
  {
    positionProps: {
      position: t.MID_RIGHT,
      offset: { topInPercent: 10, right: "10%" }
    },
    expectedStyle: {
      top: "60%",
      right: "10%",
      transform: "translateY(-50%)"
    }
  }
];
jest.mock("../../context/OverlayManagerContext");
jest.mock("../../hooks/useForwardBoundingComponentEvents");
jest.mock("../../hooks/useResizeObserver");
jest.mock("../../hooks/useForwardOverlayEvents", () => ({
  __esModule: !0,
  // This property is needed for mocking default exports
  default: jest.fn()
}));
describe("Overlay Component", () => {
  const a = { current: document.createElement("div") };
  beforeEach(() => {
    f.mockReturnValue({
      boundingComponentRef: a
    });
  }), it.each(T)("applies correct styles for position $positionProps.position and offset $positionProps.offset", ({ positionProps: e, expectedStyle: i }) => {
    const { getByRole: s } = r(
      /* @__PURE__ */ o(n, { ...e, children: "Test Content" })
    ), p = s("overlay");
    expect(p).toHaveStyle(i);
  }), it("useForwardOverlayEvents is called with correct arguments", () => {
    r(
      /* @__PURE__ */ o(n, { position: t.TOP_LEFT, children: "Test Content" })
    ), expect(d).toHaveBeenCalledWith(expect.objectContaining({
      overlayRef: expect.anything()
    }));
  }), it("renders children", () => {
    const e = "child-testid", i = /* @__PURE__ */ o("div", { "data-testid": e, children: "Test Child" }), { getByTestId: s } = r(
      /* @__PURE__ */ o(n, { position: t.TOP_LEFT, children: i })
    );
    expect(s(e)).toBeInTheDocument();
  }), it("overlay element has the correct class name", () => {
    const { getByRole: e } = r(
      /* @__PURE__ */ o(n, { position: t.TOP_LEFT, children: "Test Content" })
    );
    expect(e("overlay")).toHaveClass(c);
  }), it("updates as expected when position prop is updated", () => {
    const { rerender: e, getByRole: i } = r(
      /* @__PURE__ */ o(n, { position: t.TOP_CENTER, children: "Test Content" })
    );
    let s = i("overlay");
    expect(s).toHaveStyle({ top: 0, left: "50%" }), e(
      /* @__PURE__ */ o(n, { position: t.CENTER, children: "Test Content" })
    ), expect(s).toHaveStyle({ top: "50%", left: "50%" });
  }), it("updates as expected when offset prop is updated", () => {
    const e = { top: "10%", left: "10%" }, { rerender: i, getByRole: s } = r(
      /* @__PURE__ */ o(n, { position: t.TOP_LEFT, offset: e, children: "Test Content" })
    );
    let p = s("overlay");
    expect(p).toHaveStyle(e);
    const l = { top: "20%", left: "20%" };
    i(
      /* @__PURE__ */ o(n, { position: t.TOP_LEFT, offset: l, children: "Test Content" })
    ), expect(p).toHaveStyle(l);
  });
});
