import { r as o } from "../../../react.esm-GKFzux-6.js";
import { useOverlayManagerContext as m } from "../../context/OverlayManagerContext.js";
import a from "../useForwardBoundingComponentEvents.js";
import { makeEventOnlyMockComponentRef as s } from "./util.js";
const i = () => {
  const e = document.createElement("div");
  return e.className = "overlay", e;
}, v = () => {
  const e = i(), n = document.createElement("div");
  e.appendChild(n);
  const t = document.createElement("div");
  return n.appendChild(t), t;
}, c = (e) => {
  expect(e.current.addEventListener).toHaveBeenCalledWith("mousemove", expect.any(Function)), expect(e.current.addEventListener).toHaveBeenCalledWith("mouseleave", expect.any(Function));
}, l = (e) => {
  expect(e.current.removeEventListener).toHaveBeenCalledWith("mousemove", expect.any(Function)), expect(e.current.removeEventListener).toHaveBeenCalledWith("mouseleave", expect.any(Function));
};
jest.mock("../../context/OverlayManagerContext");
describe("useForwardBoundingComponentEvents", () => {
  const e = {
    emit: jest.fn()
  };
  let n;
  beforeEach(() => {
    n = s(), m.mockReturnValue({
      overlayManagerEventEmitter: e,
      boundingComponentRef: n
    });
  }), afterEach(() => {
    jest.clearAllMocks();
  }), it("sets up and tears down event listeners", () => {
    const { unmount: t } = o(() => a());
    c(n), t(), l(n);
  }), it("emits mousemoveOnBoundingComponent when mousemove event occurs", () => {
    o(() => a());
    const t = new Event("mousemove");
    n.current.dispatchEvent(t), expect(e.emit).toHaveBeenCalledWith("mousemoveOnBoundingComponent");
  }), it("emits mouseleaveOnBoundingComponent when mouseleave event occurs", () => {
    o(() => a());
    const t = new Event("mouseleave");
    n.current.dispatchEvent(t), expect(e.emit).toHaveBeenCalledWith("mouseleaveOnBoundingComponent");
  }), it.each([
    {
      title: "does not emit mouseleaveOnBoundingComponent when related target is an overlay",
      relatedTarget: i()
    },
    {
      title: "does not emit mouseleaveOnBoundingComponent when related target is a descendant of an overlay",
      relatedTarget: v()
    }
  ])("$title", ({ relatedTarget: t }) => {
    o(() => a());
    const r = new MouseEvent("mouseleave", { relatedTarget: t });
    n.current.dispatchEvent(r), expect(e.emit).not.toHaveBeenCalledWith("mouseleaveOnBoundingComponent");
  }), it("handles updates to boundingComponentRef correctly", () => {
    const { rerender: t } = o(() => a()), r = s();
    m.mockReturnValue({
      overlayManagerEventEmitter: e,
      boundingComponentRef: r
    }), t(), l(n), c(r);
  });
});
