import { r as o, w as m } from "../../../react.esm-GKFzux-6.js";
import { useOverlayManagerContext as i } from "../../context/OverlayManagerContext.js";
import r from "../useForwardOverlayEvents.js";
import { makeEventOnlyMockComponentRef as s } from "./util.js";
jest.mock("../../context/OverlayManagerContext");
const v = (e) => {
  expect(e.current.addEventListener).toHaveBeenCalledWith("mousemove", expect.any(Function)), expect(e.current.addEventListener).toHaveBeenCalledWith("mouseleave", expect.any(Function));
}, c = (e) => {
  expect(e.current.removeEventListener).toHaveBeenCalledWith("mousemove", expect.any(Function)), expect(e.current.removeEventListener).toHaveBeenCalledWith("mouseleave", expect.any(Function));
};
describe("useForwardOverlayEvents", () => {
  const e = {
    emit: jest.fn()
  }, n = s();
  beforeEach(() => {
    i.mockReturnValue({
      overlayManagerEventEmitter: e
    });
  }), afterEach(() => {
    jest.clearAllMocks();
  }), it("sets up and tears down event listeners", () => {
    const { unmount: t } = o(() => r({ overlayRef: n }));
    v(n), t(), c(n);
  }), it("emits mousemoveOnOverlay when mousemove event occurs", () => {
    o(() => r({ overlayRef: n }));
    const t = new Event("mousemove");
    n.current.dispatchEvent(t), expect(e.emit).toHaveBeenCalledWith("mousemoveOnOverlay");
  }), it("emits mousemoveOnOverlay when mouseleave event occurs", () => {
    o(() => r({ overlayRef: n }));
    const t = new Event("mouseleave");
    n.current.dispatchEvent(t), expect(e.emit).toHaveBeenCalledWith("mouseleaveOnOverlay", t);
  }), it("handles updates to overlayRef correctly", async () => {
    const { rerender: t } = o(({ overlayRef: l }) => r({ overlayRef: l }), {
      initialProps: { overlayRef: n }
    }), a = s();
    t({ overlayRef: a }), await m(() => {
      c(n), v(a);
    });
  }), it("does not emit any mount events when overlay element is null", () => {
    const t = { current: null };
    o(() => r({ overlayRef: t })), expect(e.emit).not.toHaveBeenCalled();
  });
});
